/*
SUSIE32 '00AM' Plug-in for LZH(LH0̂)
*/

#include <windows.h>
#include "spi00am.h"
#include "spi00am_ex.h"

CommonCache *cache;

//---------------------------------------------------------------------------
/* Gg|Cg */
BOOL APIENTRY SpiEntryPoint(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	g_hModule = hModule;
	switch (ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
			loadConfig();
			cache = new CommonCache();
			break;
		case DLL_THREAD_ATTACH:
			break;
		case DLL_THREAD_DETACH:
			break;
		case DLL_PROCESS_DETACH:
			break;
	}
	return TRUE;
}

//---------------------------------------------------------------------------
/*
wb_đΉtH[}bgmF.
ΉĂ̂Ȃtrue,łȂfalseԂ.
filname̓t@C(NULLĂ邱Ƃ).
data̓t@C̃wb_,TCY HEADBUF_SIZE.
*/
/* 2KBȓ */
BOOL IsSupportedEx(char *filename, char *data)
{
	if (memcmp(data, "%PDF-", 5) != 0) return FALSE;
	return TRUE;
}
//---------------------------------------------------------------------------
/*
filname̓t@C.
len͓ǂݍ݊JnItZbg(MacBinΉ̂).
lphInf̓t@C̓nh󂯎ϐւ̃|C^.
A[JCu擾.G[R[hԂ.

A[JCu͓ƎɂxLbVB
GetArchiveInfo ł *A[JCut@C* ̈v̂ԂB
GetFileInfo ł̓A[JCu *t@C* ̈v̂ԂB
GetFileEx œn fileInfo  *position* ̈v̂nB
*/
int GetArchiveInfoEx(LPSTR filename_b, long len, HLOCAL *lphInf)
{
	char *filename = getFilename(filename_b);
	llog(filename);
	cache->Init(filename);
	int ret;
	ret = cache->Dupli(filename, lphInf);
	if (ret != SPI_NO_FUNCTION) {
		return ret;
	}
	return GetArchiveInfoExCache(filename, len, lphInf, cache);
}
//---------------------------------------------------------------------------
/*
dest,t@C̓LOCAL[nh󂯎ϐւ̃|C^.
w肳ꂽfileInfo\̂ւ̃|C^.
G[R[hԂ.
*/
int GetFileEx(char *filename_b, HLOCAL *dest, fileInfo *pinfo,
			SPI_PROGRESS lpPrgressCallback, long lData)
{
	llog("GetFileEx");
	char *filename = getFilename(filename_b);
	unsigned long filesize;
	cache->Init(filename);
	if (cache->Get(filename, dest, &filesize, pinfo->position)) {
		return SPI_ALL_RIGHT;
	}
	return SPI_FILE_READ_ERROR;
}

